-- Address decode logic for ipbus fabric
-- 
-- This file has been AUTOGENERATED from the address table - do not hand edit
-- 
-- We assume the synthesis tool is clever enough to recognise exclusive conditions
-- in the if statement.
-- 
-- Dave Newbold, February 2011

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.numeric_std.all;

package ipbus_decode_sc_seq is

  constant IPBUS_SEL_WIDTH: positive := 5; -- Should be enough for now?
  subtype ipbus_sel_t is std_logic_vector(IPBUS_SEL_WIDTH - 1 downto 0);
  function ipbus_sel_sc_seq(addr : in std_logic_vector(31 downto 0)) return ipbus_sel_t;

-- START automatically  generated VHDL the Mon Nov 27 19:15:55 2017 
  constant N_SLV_BUF: integer := 0;
  constant N_SLV_CONF: integer := 1;
  constant N_SLV_CTRS: integer := 2;
  constant N_SLAVES: integer := 3;
-- END automatically generated VHDL

    
end ipbus_decode_sc_seq;

package body ipbus_decode_sc_seq is

  function ipbus_sel_sc_seq(addr : in std_logic_vector(31 downto 0)) return ipbus_sel_t is
    variable sel: ipbus_sel_t;
  begin

-- START automatically  generated VHDL the Mon Nov 27 19:15:55 2017 
    if    std_match(addr, "-----------------------------00-") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_BUF, IPBUS_SEL_WIDTH)); -- buf / base 0x00000000 / mask 0x00000006
    elsif std_match(addr, "-----------------------------01-") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_CONF, IPBUS_SEL_WIDTH)); -- conf / base 0x00000002 / mask 0x00000006
    elsif std_match(addr, "-----------------------------10-") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_CTRS, IPBUS_SEL_WIDTH)); -- ctrs / base 0x00000004 / mask 0x00000006
-- END automatically generated VHDL

    else
        sel := ipbus_sel_t(to_unsigned(N_SLAVES, IPBUS_SEL_WIDTH));
    end if;

    return sel;

  end function ipbus_sel_sc_seq;

end ipbus_decode_sc_seq;

