set_property BITSTREAM.Config.SPI_BUSWIDTH 4 [current_design]
set_property BITSTREAM.CONFIG.CONFIGRATE 33 [current_design]

create_clock -period 25.0 -name clk_i [get_ports clk_i_p]

set_clock_groups -asynchronous -group [get_clocks -include_generated_clocks clk_i]

set_property IOSTANDARD LVDS_25 [get_port {clk_rstn_* clk_o_* clk_i_* trig_o_* trig_i_* sync_o_* sync_i_* trig_sel_* sync_sel_* scl_* sda_* busy_o_* busy_i_*}]
set_property DIFF_TERM TRUE [get_port {clk_rstn_* clk_o_* clk_i_* trig_o_* trig_i_* sync_o_* sync_i_* trig_sel_* sync_sel_* scl_* sda_* busy_o_* busy_i_*}]
set_property PACKAGE_PIN M6 [get_ports {clk_rstn_p}]
set_property PACKAGE_PIN N6 [get_ports {clk_rstn_n}]
set_property PACKAGE_PIN L6 [get_ports {clk_o_p}]
set_property PACKAGE_PIN L5 [get_ports {clk_o_n}]
set_property PACKAGE_PIN T5 [get_ports {clk_i_p}]
set_property PACKAGE_PIN T4 [get_ports {clk_i_n}]
set_property PACKAGE_PIN M4 [get_ports {trig_o_p}]
set_property PACKAGE_PIN N4 [get_ports {trig_o_n}]
set_property PACKAGE_PIN N2 [get_ports {trig_i_p}]
set_property PACKAGE_PIN N1 [get_ports {trig_i_n}]
set_property PACKAGE_PIN R6 [get_ports {sync_o_p}]
set_property PACKAGE_PIN R5 [get_ports {sync_o_n}]
set_property PACKAGE_PIN P2 [get_ports {sync_i_p}]
set_property PACKAGE_PIN R2 [get_ports {sync_i_n}]
set_property PACKAGE_PIN R7 [get_ports {trig_sel_p}]
set_property PACKAGE_PIN T6 [get_ports {trig_sel_n}]
set_property PACKAGE_PIN U1 [get_ports {sync_sel_p}]
set_property PACKAGE_PIN V1 [get_ports {sync_sel_n}]
set_property PACKAGE_PIN U4 [get_ports {scl_p}]
set_property PACKAGE_PIN U3 [get_ports {scl_n}]
set_property PACKAGE_PIN L1 [get_ports {sda_o_p}]
set_property PACKAGE_PIN M1 [get_ports {sda_o_n}]
set_property PACKAGE_PIN K5 [get_ports {sda_i_p}]
set_property PACKAGE_PIN L4 [get_ports {sda_i_n}]
set_property PACKAGE_PIN F4 [get_ports {busy_o_p}]
set_property PACKAGE_PIN F3 [get_ports {busy_o_n}]
set_property PACKAGE_PIN E2 [get_ports {busy_i_p[0]}]
set_property PACKAGE_PIN D2 [get_ports {busy_i_n[0]}]
set_property PACKAGE_PIN G4 [get_ports {busy_i_p[1]}]
set_property PACKAGE_PIN G3 [get_ports {busy_i_n[1]}]
set_property PACKAGE_PIN F1 [get_ports {busy_i_p[2]}]
set_property PACKAGE_PIN E1 [get_ports {busy_i_n[2]}]
set_property PACKAGE_PIN G6 [get_ports {busy_i_p[3]}]
set_property PACKAGE_PIN F6 [get_ports {busy_i_n[3]}]
set_property PACKAGE_PIN H2 [get_ports {busy_i_p[4]}]
set_property PACKAGE_PIN G2 [get_ports {busy_i_n[4]}]
set_property PACKAGE_PIN J3 [get_ports {busy_i_p[5]}]
set_property PACKAGE_PIN J2 [get_ports {busy_i_n[5]}]
set_property PACKAGE_PIN H6 [get_ports {busy_i_p[6]}]
set_property PACKAGE_PIN H5 [get_ports {busy_i_n[6]}]
set_property PACKAGE_PIN H1 [get_ports {busy_i_p[7]}]
set_property PACKAGE_PIN G1 [get_ports {busy_i_n[7]}]
# busy 8,9 clash with cfg[3..0] so make sure these ports are commented out in enclustra_ax3_pm3.tcl
set_property PACKAGE_PIN K2 [get_ports {busy_i_p[8]}]
set_property PACKAGE_PIN K1 [get_ports {busy_i_n[8]}]
set_property PACKAGE_PIN C4 [get_ports {busy_i_p[9]}]
set_property PACKAGE_PIN B4 [get_ports {busy_i_n[9]}]
false_path {clk_rstn_* clk_o_* clk_i_* trig_o_* trig_i_* sync_o_* sync_i_* trig_sel_* sync_sel_* scl_* sda_* busy_o_* busy_i_*} sysclk
